From: Steven Baltakatei Sandoval <baltakatei@gmail.com>
Date: Tue, 26 Jul 2022 18:48:37 +0000 (+0000)
Subject: feat(user/):Add script to convert files to FLAC with ffmpeg
X-Git-Tag: 0.5.1~11
X-Git-Url: https://zdv2.bktei.com/gitweb/BK-2020-03.git/commitdiff_plain/54469ce4057294faebb283d7ed97e4d4ae89419d?ds=sidebyside

feat(user/):Add script to convert files to FLAC with ffmpeg

	new file:   user/convert_file_to_flac.sh
---

diff --git a/user/convert_file_to_flac.sh b/user/convert_file_to_flac.sh
new file mode 100644
index 0000000..f21a0fc
--- /dev/null
+++ b/user/convert_file_to_flac.sh
@@ -0,0 +1,223 @@
+#!/bin/bash
+# Desc: Converts file readable by ffmpeg to FLAC audio format
+# Usage: convert_file_to_flac.sh [path]
+# Version: 0.0.1
+# Ref/Attrib: [1] Convert audio file to FLAC with ffmpeg? https://superuser.com/a/802126
+
+declare -Ag appRollCall # Associative array for storing app status
+declare -Ag fileRollCall # Associative array for storing file status
+declare -Ag dirRollCall # Associative array for storing dir status
+
+yell() { echo "$0: $*" >&2; } # print script path and all args to stderr
+die() { yell "$*"; exit 111; } # same as yell() but non-zero exit status
+try() { "$@" || die "cannot $*"; } # runs args as command, reports args if command fails
+checkapp() {
+    # Desc: If arg is a command, save result in assoc array 'appRollCall'
+    # Usage: checkapp arg1 arg2 arg3 ...
+    # Version: 0.1.1
+    # Input: global assoc. array 'appRollCall'
+    # Output: adds/updates key(value) to global assoc array 'appRollCall'
+    # Depends: bash 5.0.3
+    local returnState    
+
+    #===Process Args===
+    for arg in "$@"; do
+	if command -v "$arg" 1>/dev/null 2>&1; then # Check if arg is a valid command
+	    appRollCall[$arg]="true";
+	    if ! [ "$returnState" = "false" ]; then returnState="true"; fi;
+	else
+	    appRollCall[$arg]="false"; returnState="false";
+	fi;
+    done;
+
+    #===Determine function return code===
+    if [ "$returnState" = "true" ]; then
+	return 0;
+    else
+	return 1;
+    fi;
+} # Check that app exists
+checkfile() {
+    # Desc: If arg is a file path, save result in assoc array 'fileRollCall'
+    # Usage: checkfile arg1 arg2 arg3 ...
+    # Version: 0.1.1
+    # Input: global assoc. array 'fileRollCall'
+    # Output: adds/updates key(value) to global assoc array 'fileRollCall';
+    # Output: returns 0 if app found, 1 otherwise
+    # Depends: bash 5.0.3
+    local returnState
+
+    #===Process Args===
+    for arg in "$@"; do
+	if [ -f "$arg" ]; then
+	    fileRollCall["$arg"]="true";
+	    if ! [ "$returnState" = "false" ]; then returnState="true"; fi;
+	else
+	    fileRollCall["$arg"]="false"; returnState="false";
+	fi;
+    done;
+    
+    #===Determine function return code===
+    if [ "$returnState" = "true" ]; then
+	return 0;
+    else
+	return 1;
+    fi;
+} # Check that file exists
+checkdir() {
+    # Desc: If arg is a dir path, save result in assoc array 'dirRollCall'
+    # Usage: checkdir arg1 arg2 arg3 ...
+    # Version 0.1.2
+    # Input: global assoc. array 'dirRollCall'
+    # Output: adds/updates key(value) to global assoc array 'dirRollCall';
+    # Output: returns 0 if all args are dirs; 1 otherwise
+    # Depends: Bash 5.0.3
+    local returnState
+
+    #===Process Args===
+    for arg in "$@"; do
+	if [ -z "$arg" ]; then
+	    dirRollCall["(Unspecified Dirname(s))"]="false"; returnState="false";
+	elif [ -d "$arg" ]; then
+	    dirRollCall["$arg"]="true";
+	    if ! [ "$returnState" = "false" ]; then returnState="true"; fi
+	else
+	    dirRollCall["$arg"]="false"; returnState="false";
+	fi
+    done
+    
+    #===Determine function return code===
+    if [ "$returnState" = "true" ]; then
+	return 0;
+    else
+	return 1;
+    fi
+} # Check that dir exists
+displayMissing() {
+    # Desc: Displays missing apps, files, and dirs
+    # Usage: displayMissing
+    # Version 1.0.0
+    # Input: associative arrays: appRollCall, fileRollCall, dirRollCall
+    # Output: stderr: messages indicating missing apps, file, or dirs
+    # Output: returns exit code 0 if nothing missing; 1 otherwise
+    # Depends: bash 5, checkAppFileDir()
+    local missingApps value appMissing missingFiles fileMissing
+    local missingDirs dirMissing
+
+    #==BEGIN Display errors==
+    #===BEGIN Display Missing Apps===
+    missingApps="Missing apps  :";
+    #for key in "${!appRollCall[@]}"; do echo "DEBUG:$key => ${appRollCall[$key]}"; done
+    for key in "${!appRollCall[@]}"; do
+	value="${appRollCall[$key]}";
+	if [ "$value" = "false" ]; then
+	    #echo "DEBUG:Missing apps: $key => $value";
+	    missingApps="$missingApps""$key ";
+	    appMissing="true";
+	fi;
+    done;
+    if [ "$appMissing" = "true" ]; then  # Only indicate if an app is missing.
+	echo "$missingApps" 1>&2;
+    fi;
+    unset value;
+    #===END Display Missing Apps===
+
+    #===BEGIN Display Missing Files===
+    missingFiles="Missing files:";
+    #for key in "${!fileRollCall[@]}"; do echo "DEBUG:$key => ${fileRollCall[$key]}"; done
+    for key in "${!fileRollCall[@]}"; do
+	value="${fileRollCall[$key]}";
+	if [ "$value" = "false" ]; then
+	    #echo "DEBUG:Missing files: $key => $value";
+	    missingFiles="$missingFiles""$key ";
+	    fileMissing="true";
+	fi;
+    done;
+    if [ "$fileMissing" = "true" ]; then  # Only indicate if an app is missing.
+	echo "$missingFiles" 1>&2;
+    fi;
+    unset value;
+    #===END Display Missing Files===
+
+    #===BEGIN Display Missing Directories===
+    missingDirs="Missing dirs:";
+    #for key in "${!dirRollCall[@]}"; do echo "DEBUG:$key => ${dirRollCall[$key]}"; done
+    for key in "${!dirRollCall[@]}"; do
+	value="${dirRollCall[$key]}";
+	if [ "$value" = "false" ]; then
+	    #echo "DEBUG:Missing dirs: $key => $value";
+	    missingDirs="$missingDirs""$key ";
+	    dirMissing="true";
+	fi;
+    done;
+    if [ "$dirMissing" = "true" ]; then  # Only indicate if an dir is missing.
+	echo "$missingDirs" 1>&2;
+    fi;
+    unset value;
+    #===END Display Missing Directories===
+
+    #==END Display errors==
+    #==BEGIN Determine function return code===
+    if [ "$appMissing" == "true" ] || [ "$fileMissing" == "true" ] || [ "$dirMissing" == "true" ]; then
+	return 1;
+    else
+	return 0;
+    fi
+    #==END Determine function return code===
+} # Display missing apps, files, dirs
+check_parsable_audio_ffprobe() {
+    # Desc: Checks if ffprobe returns valid audio codec name for file
+    # Usage: check_parsable_audio_ffprobe [path FILE]
+    # Version: 0.0.1
+    # Input: arg1: file path
+    # Output: exit code 0 if returns valid codec name; 1 otherwise
+    # Depends: ffprobe, die()
+    local file_in ffprobe_out
+
+    if [[ $# -ne 1 ]]; then die "ERROR:Invalid number of args:$#"; fi;
+    
+    file_in="$1";
+    
+    # Check if ffprobe detects an audio stream
+    if ffprobe -v error -select_streams a -show_entries stream=codec_name -of default=nokey=1:noprint_wrappers=1 "$file_in" 1>/dev/null 2>&1; then
+	return_state="true";
+    else
+	return_state="false";
+    fi;
+
+    # Fail if ffprobe returns no result
+    ffprobe_out="$(ffprobe -v error -select_streams a -show_entries stream=codec_name -of default=nokey=1:noprint_wrappers=1 "$file_in")";
+    if [[ -z $ffprobe_out ]]; then
+	return_state="false";
+    fi;
+    
+    # Report exit code
+    if [[ $return_state = "true" ]]; then
+	return 0;
+    else
+	return 1;
+    fi;
+} # Checks if file has valid codec name using ffprobe
+main() {
+    # Check inputs
+    if [[ ! -f $1 ]]; then die "FATAL:Not a file:$1"; fi;
+    if [[ $# -ne 1 ]]; then die "FATAL:Arguments not equal to 1:$#"; fi;
+
+    # Check depends
+    if ! checkapp ffmpeg ffprobe; then
+        displayMissing;
+        die "FATAL:Missing apps"; fi;
+
+
+    # Check file is parsable by ffprobe
+    if ! check_parsable_audio_ffprobe "$1"; then
+        die "FATAL:Not an audio file:$1"; fi;
+    
+    # Convert file to FLAC
+    try ffmpeg -i "$1" -f "$1".flac
+}; # main program
+
+main "$@";
+
+# Author: Steven Baltakatei Sandoval
+# License: GPLv3+